﻿Imports System
Imports System.Windows
Imports System.Windows.Media
Imports System.Windows.Navigation
Imports Microsoft.Phone.Controls
Imports Microsoft.Phone.Shell


Partial Public Class MainPage
    Inherits PhoneApplicationPage
    Public Sub New()
        InitializeComponent()

        ' Get app bar buttons
        playButton = TryCast(Me.ApplicationBar.Buttons(0), ApplicationBarIconButton)
        pauseButton = TryCast(Me.ApplicationBar.Buttons(1), ApplicationBarIconButton)
    End Sub

    Protected Overrides Sub OnNavigatedTo(ByVal args As NavigationEventArgs)
        ' Set MediaStreamSource derivative to MediaElement
        MediaElement.SetSource(New Sine440AudioStreamSource(44100))
        MyBase.OnNavigatedTo(args)
    End Sub

    Private Sub OnMediaElementCurrentStateChanged(ByVal sender As Object, ByVal args As RoutedEventArgs)
        statusTextBlock.Text = mediaElement.CurrentState.ToString
        playButton.IsEnabled = MediaElement.CurrentState <> MediaElementState.Playing
        pauseButton.IsEnabled = MediaElement.CurrentState = MediaElementState.Playing
    End Sub

    Private Sub OnPlayButtonClick(ByVal sender As Object, ByVal args As EventArgs)
        mediaElement.Play()
        playButton.IsEnabled = False
    End Sub

    Private Sub OnPauseButtonClick(ByVal sender As Object, ByVal args As EventArgs)
        MediaElement.Pause()
        pauseButton.IsEnabled = False
    End Sub
End Class
