﻿Imports System
Imports Microsoft.Phone.BackgroundAudio
Imports Microsoft.Phone.Controls
Imports Microsoft.Phone.Shell


Partial Public Class MainPage
    Inherits PhoneApplicationPage
    Public Sub New()
        InitializeComponent()
        playButton = TryCast(Me.ApplicationBar.Buttons(0), ApplicationBarIconButton)
        pauseButton = TryCast(Me.ApplicationBar.Buttons(1), ApplicationBarIconButton)

        AddHandler BackgroundAudioPlayer.Instance.PlayStateChanged, AddressOf OnBackgroundAudioPlayerPlayStateChanged

        ' Initialize by calling event handler manually
        OnBackgroundAudioPlayerPlayStateChanged(Nothing, EventArgs.Empty)
    End Sub

    Private Sub OnBackgroundAudioPlayerPlayStateChanged(ByVal sender As Object, ByVal args As EventArgs)
        Dim playState As PlayState = BackgroundAudioPlayer.Instance.PlayerState

        statusTextBlock.Text = "Status: " & playState

        playButton.IsEnabled = playState = playState.Paused OrElse playState = playState.Stopped OrElse playState = playState.Unknown

        pauseButton.IsEnabled = playState = playState.Playing
    End Sub

    Private Sub OnPlayButtonClick(ByVal sender As Object, ByVal args As EventArgs)
        If BackgroundAudioPlayer.Instance.Track Is Nothing Then
            BackgroundAudioPlayer.Instance.Track = New AudioTrack(Nothing, "Pentatonic Rambler", Nothing, Nothing, Nothing, Nothing, EnabledPlayerControls.Pause)
            BackgroundAudioPlayer.Instance.Volume = 1
        Else
            BackgroundAudioPlayer.Instance.Play()
        End If
        playButton.IsEnabled = False
    End Sub

    Private Sub OnPauseButtonClick(ByVal sender As Object, ByVal args As EventArgs)
        BackgroundAudioPlayer.Instance.Pause()
        pauseButton.IsEnabled = False
    End Sub
End Class
