﻿Imports System.Windows
Imports System.Windows.Controls


Partial Public Class WaveformerNode
    Inherits UserControl
    Public Shared ReadOnly PointProperty As DependencyProperty = DependencyProperty.Register("Point", GetType(Point), GetType(WaveformerNode), New PropertyMetadata(New Point(0, 0), AddressOf OnPointPropertyChanged))

    Public Sub New()
        InitializeComponent()
    End Sub

    Public Property Point() As Point
        Set(ByVal value As Point)
            SetValue(PointProperty, value)
        End Set
        Get
            Return CType(GetValue(PointProperty), Point)
        End Get
    End Property

    Private Shared Sub OnPointPropertyChanged(ByVal obj As DependencyObject, ByVal args As DependencyPropertyChangedEventArgs)
        TryCast(obj, WaveformerNode).OnPointPropertyChanged(args)
    End Sub

    Private Sub OnPointPropertyChanged(ByVal args As DependencyPropertyChangedEventArgs)
        Dim pt As Point = CType(args.NewValue, Point)
        Canvas.SetLeft(Me, pt.X - Me.ActualWidth / 2)
        Canvas.SetTop(Me, pt.Y - Me.ActualHeight / 2)
    End Sub
End Class
