﻿Imports Microsoft.VisualBasic
Imports System.Collections.Generic


Public Class Mixer
    Implements IStereoSampleProvider
    Public Sub New()
        Me.Inputs = New List(Of MixerInput)
        Me.Volume = 1
    End Sub

    Private _inputs As IList(Of MixerInput)
    Public Property Inputs As IList(Of MixerInput)
        Get
            Return _inputs
        End Get
        Protected Set(ByVal value As IList(Of MixerInput))
            _inputs = value
        End Set
    End Property

    Public Property Volume As Double

    Public Function GetNextSample() As AudioSample Implements IStereoSampleProvider.GetNextSample
        Dim left As Integer = 0
        Dim right As Integer = 0

        For Each mixerInput As MixerInput In Me.Inputs
            Dim audioSample As AudioSample = mixerInput.GetNextSample()
            left += audioSample.Left
            right += audioSample.Right
        Next mixerInput

        Return New AudioSample With {.Left = CShort(Fix(Me.Volume * left \ Me.Inputs.Count)), .Right = CShort(Fix(Me.Volume * right \ Me.Inputs.Count))}
    End Function
End Class
