﻿Public Class Rambler
    Inherits SteadyNoteDurationPlayer
    Private random As New Random
    Private currentPitch As Pitch

    Public Sub New(ByVal sampleRate As Integer, ByVal start As Pitch, ByVal lowerLimit As Pitch, ByVal upperLimit As Pitch)
        MyBase.New(sampleRate)
        Me.Notes = New List(Of Note)
        Me.Start = start
        Me.LowerLimit = lowerLimit
        Me.UpperLimit = upperLimit

        currentPitch = Me.Start
    End Sub

    Private _notes As IList(Of Note)
    Public Property Notes As IList(Of Note)
        Get
            Return _notes
        End Get
        Protected Set(ByVal value As IList(Of Note))
            _notes = value
        End Set
    End Property

    Private _start As Pitch
    Public Property Start As Pitch
        Get
            Return _start
        End Get
        Protected Set(ByVal value As Pitch)
            _start = value
        End Set
    End Property

    Private _lowerLimit As Pitch
    Public Property LowerLimit As Pitch
        Get
            Return _lowerLimit
        End Get
        Protected Set(ByVal value As Pitch)
            _lowerLimit = value
        End Set
    End Property

    Private _upperLimit As Pitch
    Public Property UpperLimit As Pitch
        Get
            Return _upperLimit
        End Get
        Protected Set(ByVal value As Pitch)
            _upperLimit = value
        End Set
    End Property

    Protected Overrides Function GetNextPitch() As Pitch
        If Me.Notes.Count = 0 Then
            Return New Pitch
        End If

        Dim noteIndex As Integer = Me.Notes.IndexOf(currentPitch.Note)
        Dim octave As Integer = currentPitch.Octave
        Dim goUp As Boolean = False

        If currentPitch.Equals(Me.UpperLimit) Then
            goUp = False
        ElseIf currentPitch.Equals(Me.LowerLimit) Then
            goUp = True
        Else
            goUp = random.Next(2) = 0
        End If

        If goUp Then
            If noteIndex = Me.Notes.Count - 1 Then
                currentPitch = New Pitch(Me.Notes(0), octave + 1)
            Else
                currentPitch = New Pitch(Me.Notes(noteIndex + 1), octave)
            End If
        Else
            If noteIndex = 0 Then
                currentPitch = New Pitch(Me.Notes(Me.Notes.Count - 1), octave - 1)
            Else
                currentPitch = New Pitch(Me.Notes(noteIndex - 1), octave)
            End If
        End If
        Return currentPitch
    End Function
End Class
