﻿Imports System.Collections.Generic

Public Class Sequencer
    Inherits SteadyNoteDurationPlayer
    Private noteIndex As Integer = -1

    Public Sub New(ByVal sampleRate As Integer)
        MyBase.New(sampleRate)
        Me.Pitches = New List(Of Pitch)
    End Sub

    Private _pitches As IList(Of Pitch)
    Public Property Pitches As IList(Of Pitch)
        Get
            Return _pitches
        End Get
        Protected Set(ByVal value As IList(Of Pitch))
            _pitches = value
        End Set
    End Property

    Protected Overrides Function GetNextPitch() As Pitch
        If Me.Pitches.Count = 0 Then
            Return New Pitch
        End If

        noteIndex += 1

        If noteIndex >= Me.Pitches.Count Then
            noteIndex = 0
        End If

        Return Me.Pitches(noteIndex)
    End Function
End Class
