﻿
Public MustInherit Class SteadyNoteDurationPlayer
    Implements IMonoSampleProvider
    Private sampleRate As Integer

    Private noteInterval As TimeSpan

    Private currentNoteDuration As TimeSpan

    Private pitch As Pitch

    Private Sub New()
    End Sub

    Protected Sub New(ByVal sampleRate As Integer)
        Me.sampleRate = sampleRate
        Me.Tempo = 60
    End Sub

    Public Property Oscillator As Oscillator

    ' In quarter notes per minute
    Public Property Tempo As Integer
        Set(ByVal value As Integer)
            noteInterval = TimeSpan.FromMinutes(1.0 / value)
        End Set
        Get
            Return CInt(Fix(1 / noteInterval.TotalMinutes))
        End Get
    End Property

    Public Function GetNextSample() As Short Implements IMonoSampleProvider.GetNextSample
        If Me.Oscillator Is Nothing Then
            Return 0
        End If

        ' First time through or note finished playing
        If pitch.Frequency = 0 OrElse currentNoteDuration <= TimeSpan.Zero Then
            pitch = GetNextPitch()
            Me.Oscillator.Frequency = pitch.Frequency
            currentNoteDuration = noteInterval
        End If

        currentNoteDuration = currentNoteDuration - TimeSpan.FromTicks(CLng(Fix(10000000.0 / sampleRate)))
        Return Me.Oscillator.GetNextSample()
    End Function

    Protected MustOverride Function GetNextPitch() As Pitch
End Class
