﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Windows
Imports System.Collections.Generic


Public Class VariableWaveformOscillator
    Inherits Oscillator
    Public Sub New(ByVal sampleRate As Integer)
        MyBase.New(sampleRate)
        Me.Points = New List(Of Point)
    End Sub

    Public Property Points As IList(Of Point)

    Public Overrides Function GetNextSample(ByVal angle As Double) As Short
        If Me.Points Is Nothing OrElse Me.Points.Count = 0 Then
            Return 0
        End If

        ' Assumes Points are ordered by angle (X) and evenly distributed w/o first and last
        Dim index2 As Integer = CInt(Fix((Me.Points.Count + 1) * angle / (2 * Math.PI)))
        Dim index1 As Integer = index2 - 1

        Dim point1 As Point = If(index1 = -1, New Point(0, 0), Me.Points(index1))
        Dim point2 As Point = If(index2 = Me.Points.Count, New Point(2 * Math.PI, 0), Me.Points(index2))

        Return Interpolate(angle, point1, point2)
    End Function

    Private Function Interpolate(ByVal angle As Double, ByVal point1 As Point, ByVal point2 As Point) As Short
        Return CShort(Fix(Short.MaxValue * (point1.Y * (point2.X - angle) + point2.Y * (angle - point1.X)) / (point2.X - point1.X)))
    End Function
End Class
